program MSet;  {Produces a full sized Mandelbrot set in Pascal}
{$G+,N+,E+}
uses crt, vga2pcx;

var xcorner, ycorner, side: double;
    i, j, psize, xgap, ygap: word;
    ca, cb, za1, za2, zb: double;
    opt: char;
    fl: boolean;
    count, max: byte;

procedure setvideo(m: byte); assembler;
asm
xor ah,ah
mov al,[m]
int 10h
end;

procedure setwrite; assembler;
asm
mov dx,03ceh  {Graphics controller}
mov ax,0205h  {Mode register, write mode 2}
out dx,ax
end;

procedure pset(x, y: word; c: byte); assembler;
asm
mov ax,SegA000  {Calculate offset}
mov es,ax
mov bx,[y]
mov di,bx
shl di,6        {80*y}
shl bx,4
add di,bx

mov cx,[x]
mov bx,cx
shr bx,3        {x/8}
add di,bx       {80*y + x/8}

and cx,7        {Get bit that changes}
mov ah,128
shr ah,cl
mov dx,03ceh
mov al,8
out dx,ax
mov dl,[es:di]
mov al,[c]
mov [es:di],al
end;

procedure iterate;  {The heart of the program - performs the calculations
                    necessary to determine the colour}
begin
count := 1;
za1 := 0.0;
za2 := 0.0;
zb := 0.0;
while count < max do begin
  za1 := za2;
  za2 := za1 * za1 - zb * zb + ca;
  zb := 2.0 * za1 * zb + cb;
  if za2 * za2 + zb * zb > 4.0 then break;
  inc(count);
end;
if count = max then count := 0;
end;

begin
clrscr;
xcorner := -2.1;  {corner of the full-sized M set}
ycorner := -1.4;
side := 2.8;
max := 32;        {maximum count before stopping iteration -
                  a high count is better for high magnification but
                  for the full sized M set it can be quite small}
write('Do you want to select the area?');
readln(opt);
if UpCase(opt) = 'Y' then begin
  write('Top left X corner=', xcorner:4:1, ', now?');
  readln(xcorner);
  write('Top left Y corner=', ycorner:4:1, ', now?');
  readln(ycorner);
  write('Side=', side:4:1, ', now?');
  readln(side);
  write('Iterations=', max, ', now?');
  readln(max);
end;
write('Do you want to save on disk?');
readln(opt);
psize := 400;  {pixel size}
xgap := 120;
ygap := 40;
side := side / psize;
setvideo($12);
setwrite;

for j := psize downto 1 do
  for i := 1 to psize do begin
    ca := i * side + xcorner;
    cb := j * side + ycorner;
    iterate;
    if count > 15 then count := (count - 1) mod 15 + 1;
    pset(xgap + i, ygap + psize - j, count);
   end;
repeat until KeyPressed;

if UpCase(opt) = 'Y' then begin
  fl := True;
  write_pcx('MSET.PCX', fl);
end;
setvideo($03);
end.