program voxel;

uses crt,dos
{$IFDEF FPC}
,go32
{$ENDIF}
;

const
 pal : array[0..383] of byte =
 (0,0,0,48,48,48,1,0,43,1,3,43,2,5,44,2,7,44,3,9,45,4,11,46,5,13,47,6,15,48,
  7,17,49,8,19,50,9,21,51,10,22,52,11,24,52,12,26,54,13,28,54,14,30,56,15,32,
  56,16,34,58,17,34,58,17,36,58,18,38,60,19,40,60,20,42,62,21,44,62,10,31,0,
  11,31,0,11,31,1,11,32,1,12,32,1,12,32,2,12,33,2,13,33,2,14,33,3,15,33,3,15,
  34,3,15,34,4,15,35,4,16,35,4,16,35,5,16,36,5,17,36,5,17,36,6,18,37,6,18,38,
  7,19,38,8,20,39,8,20,40,9,21,40,10,22,41,10,22,42,11,23,42,12,24,43,12,24,
  44,13,25,44,14,25,45,14,26,46,15,27,46,16,27,47,17,28,47,18,28,48,19,29,49,
  19,30,49,20,30,50,21,31,51,21,32,51,22,32,52,23,33,53,23,34,53,24,34,54,25,
  35,55,25,36,55,26,36,56,27,37,57,27,38,57,27,39,57,27,41,57,27,42,57,27,43,
  57,27,44,57,27,45,57,27,46,57,27,47,57,27,49,57,27,50,57,27,51,57,27,52,57,
  27,53,57,27,55,57,27,56,57,27,57,57,27,58,57,27,58,57,26,58,57,25,58,57,24,
  58,56,23,58,55,22,58,54,20,58,53,19,58,51,18,58,50,17,58,50,16,58,49,15,58,
  48,14,58,47,13,58,46,12,58,45,11,58,44,11,58,44,10,58,43,10,58,42,9,57,41,
  8,57,40,8,56,39,7,56,38,6,55,37,5,55,35,4,54,33,4,54,31,2,32,32,32,63,63,63,
  63,63,63,63,63,63,63,63,63,48,48,48,63,63,63,63,63,63);
 dim = 1 shl 7;

type
 buf = array[0..63999] of byte;
 lrgarr = array[0..dim*dim-1] of byte;

var
 scr : ^buf;
 mp : ^lrgarr;
 rng : array[0..319] of byte;
 x,y,dir : integer;
 fin : boolean;
 FN : String;
 F : File;
 Ln,Mk : Byte;

function ncol(mc,n,dvd : integer) : integer;
var loc : integer;
begin
 loc:=(mc+n-random(2*n)) div dvd;
 if loc<5 then ncol:=5
 else if loc>250 then ncol:=250
 else ncol:=loc;
end;

procedure plasma(x1,y1,x2,y2 : word);
var xn,yn,dxy,p1,p2,p3,p4,adr : word;
begin
 if (x2-x1>1) and (y2-y1>1) then
 begin
  adr:=(dim*y1+x1) and (dim*dim-1); p1:=mp^[adr];
  adr:=(dim*y2+x1) and (dim*dim-1); p2:=mp^[adr];
  adr:=(dim*y1+x2) and (dim*dim-1); p3:=mp^[adr];
  adr:=(dim*y2+x2) and (dim*dim-1); p4:=mp^[adr];
  xn:=(x2+x1) shr 1; yn:=(y2+y1) shr 1;
  dxy:=5*(x2-x1+y2-y1) div 3;
  adr:=(dim*y1+xn) and (dim*dim-1);
  if mp^[adr]=0 then mp^[adr]:=ncol(p1+p3,dxy,2);
  adr:=(dim*yn+x1) and (dim*dim-1);
  if mp^[adr]=0 then mp^[adr]:=ncol(p1+p2,dxy,2);
  adr:=(dim*yn+x2) and (dim*dim-1);
  if mp^[adr]=0 then mp^[adr]:=ncol(p3+p4,dxy,2);
  adr:=(dim*y2+xn) and (dim*dim-1);
  if mp^[adr]=0 then mp^[adr]:=ncol(p2+p4,dxy,2);
  adr:=(dim*yn+xn) and (dim*dim-1);
  mp^[adr]:=ncol(p1+p2+p3+p4,dxy,4);
  plasma(x1,y1,xn,yn); plasma(xn,y1,x2,yn);
  plasma(x1,yn,xn,y2); plasma(xn,yn,x2,y2);
 end;
end;

procedure draw(xp,yp,dir : integer);
var ix,iy,iy1,iyp,ixp,x,y,z,zobs,s,csf,snf,mpc,i,j : integer;
adr : word;
begin
 fillchar(scr^,64000,0);
 fillchar(rng,sizeof(rng),200);
 adr:=(dim*word(yp)+xp) and (dim*dim-1); zobs:=100+mp^[adr];
 csf:=round(dim*cos(dir/180*pi));
 snf:=round(dim*sin(dir/180*pi));
 for iy:=yp to yp+55 do
 begin
  iy1:=1+2*(iy-yp); s:=4+300 div iy1;
  for ix:=xp+yp-iy to xp-yp+iy do
  begin
   ixp:=xp+((ix-xp)*csf+(iy-yp)*snf) div dim;
   iyp:=yp+((iy-yp)*csf-(ix-xp)*snf) div dim;
   x:=160+360*(ix-xp) div iy1;
   if (x>=0) and (x+s<=319) then
   begin
    adr:=(dim*word(iyp)+ixp+dim*dim) and (dim*dim-1); z:=mp^[adr];
    mpc:=z shr 1; if z<45 then z:=45;
    y:=100+(zobs-z)*30 div iy1;
    if (y>=0) and (y<=199) then
     for i:=x to x+s do
     begin
      adr:=320*word(y)+i;
      for j:=y to rng[i] do
      begin
       if adr<64000 then scr^[adr]:=mpc;
       inc(adr,320);
      end;
      if y<rng[i] then rng[i]:=y
     end;
   end;
  end;
 end;
{$IFDEF VER70}
 move(scr^,mem[$a000:0],64000);
{$ENDIF}
{$IFDEF FPC}
 dosmemput($a000,0,scr^,64000);
{$ENDIF}
end;

Procedure Set_Video (VM : Byte);

Var
  Reg : Registers;

Begin
  FillChar (Reg,SizeOf(Reg),0);
  Reg.AL := VM;
  Intr ($10,Reg);
End;

Procedure Set_Palette;

Var
  I : Integer;

Begin
{$IFDEF VER70}
  Port [$3C8]:=0;
  For I:=0 to 383 Do Port [$3C9]:=pal [I];
{$ENDIF}
{$IFDEF FPC}
  OutPortB ($3C8,0);
  For I:=0 to 383 Do OutPortB ($3C9,pal [I]);
{$ENDIF}
End;

Procedure Write_Header;

Var
  B : Byte;
  I,L : Integer;

Begin
  B := 10;                              (*  Manufacturer                *)
  BlockWrite (F,B,1);
  B := 5;                               (*  Version                     *)
  BlockWrite (F,B,1);
  B := 1;                               (*  Encoding                    *)
  BlockWrite (F,B,1);
  B := 8;                               (*  Bytes Per Pixel             *)
  BlockWrite (F,B,1);
  I := 0;                               (*  Min X                       *)
  BlockWrite (F,I,2);
  I := 0;                               (*  Min Y                       *)
  BlockWrite (F,I,2);
  I := 319;                             (*  Max X                       *)
  BlockWrite (F,I,2);
  I := 199;                             (*  Max Y                       *)
  BlockWrite (F,I,2);
  I := 0;                               (*  Horizontal Resolution       *)
  BlockWrite (F,I,2);
  I := 0;                               (*  Vertical Resolution         *)
  BlockWrite (F,I,2);
  B := 0;                               (*  16 Color Palette            *)
  For L := 1 to 48 Do BlockWrite (F,B,1);
  B := 0;                               (*  Reserved                    *)
  BlockWrite (F,B,1);
  B := 1;                               (*  Color Planes                *)
  BlockWrite (F,B,1);
  I := 320;                             (*  Bytes Per Line              *)
  BlockWrite (F,I,2);
  I := 1;                               (*  Palette Type                *)
  BlockWrite (F,I,2);
  I := 320;                             (*  Horizontal Size             *)
  BlockWrite (F,I,2);
  I := 200;                             (*  Vertical Size               *)
  BlockWrite (F,I,2);
  B := 0;                               (*  Filler                      *)
  For L := 1 to 54 Do BlockWrite (F,B,1);
End;

Procedure Encode_Line (Ln : Byte);

Var
  T,L : Integer;
  A : Byte;
  P : Array [0..319] of Byte;

Begin
  T := 0;
{$IFDEF VER70}
  Move (Mem [$A000:Ln * 320],P [0],320);
{$ENDIF}
{$IFDEF FPC}
  DosMemGet ($A000,Ln * 320,P [0],320);
{$ENDIF}
  While (T < 320) Do
  Begin
    L := 1;
    While (T + L < 320) And ((P [T] = P [T + L]) And (L < 63)) Do
      Inc (L);
    If (L > 1) Then
    Begin
      A := L Or 192;
      BlockWrite (F,A,1);
      BlockWrite (F,P [T],1);
      Inc (T,L);
    End
    Else Begin
      If ((P [T] And 192) = 192) Then
      Begin
        A := 193;
        BlockWrite (F,A,1);
      End;
      BlockWrite (F,P [T],1);
      Inc (T);
    End;
  End;
End;

Procedure Write_Palette;

Var
  B : Byte;
  L : Integer;

Begin
  B := 12;
  BlockWrite (F,B,1);
{$IFDEF VER70}
  Port [$3C7] := 0;
{$ENDIF}
{$IFDEF FPC}
  OutPortB ($3C7,0);
{$ENDIF}
  For L := 0 to 767 Do
  Begin
{$IFDEF VER70}
    B := Port [$3C9] * 4;
{$ENDIF}
{$IFDEF FPC}
    B := InPortB ($3C9) * 4;
{$ENDIF}
    BlockWrite (F,B,1);
  End;
End;

begin
 x:=0; y:=0; dir:=0;
 new(mp); fillchar(mp^,dim*dim,0);
 randomize;
 mp^[0]:=128; plasma(0,0,dim,dim);
 Set_Video ($13);
 Set_Palette;
 new(scr);
 Mk := 1;
 fin:=false;
 repeat
  dir:=dir mod 360;
  draw(x,y,dir);
  case readkey of
   #0:case readkey of
     #75:dec(dir,10);
     #77:inc(dir,10);
     #72:begin
       y:=y+round(5*cos(dir/180*pi));
       x:=x+round(5*sin(dir/180*pi));
     end;
     #80:begin
       y:=y-round(5*cos(dir/180*pi));
       x:=x-round(5*sin(dir/180*pi));
     end;
   end;
   #32:begin
     Str (Mk,FN);     
     Mk := Mk + 1;
     Assign (F,'LAND'+FN+'.PCX');
     Rewrite (F,1);
     Write_Header;
     For Ln := 0 to 199 Do Encode_Line (Ln);
     Write_Palette;
     Close (F);
   end;
   #27:begin
     Set_Video ($3);
     fin:=true;
   end;
  end;
 until fin;
end.
